/**
 * Created by mac on 9/20/18
 */

if (typeof window !== 'undefined') {
    window.errorLastSend = 0;
    window.onerror = function (msg, url, lineNo, columnNo, error) {
        var message = [new Date() + ''];

        message.push('BaseOnError');

        if (error && error.arguments) {
            message.push('Arguments: ' + error.arguments);
        }

        if (!error || !error.stack) {
            message.push('Message: ' + msg);
            message.push('URL: ' + url);
            message.push('Line: ' + lineNo);
            message.push('Column: ' + columnNo);
            message.push('Error: ' + JSON.stringify(error));
        }
        else {
            message.push('Message: ' + msg);
            message.push('Line: ' + lineNo);
            message.push('Column: ' + columnNo);
            message.push(error.stack);
        }

        message.push((window && window.navigator) ? window.navigator.userAgent : '???');

        message = message.join(' - ');
        message = message.replace(/(?:\r\n|\r|\n)/g, ' - ') + ' ';

        if ((Date.now() - window.errorLastSend) >= 60 * 6000) {
            cleverappsSendRequest("POST", '/log/', message);

            window.errorLastSend = Date.now();
        }

        return false;
    }
}