/**
 * Created by slava on 7/17/17.
 */

var LogTimeStart = function (id) {
    this.id = id;

    this.started = Date.now();
};

LogTimeStart.LONG = 10000;

cleverappsCalcSource = function () {
    var config = document.ccConfig;
    if (config && ["instant", "huzcom", "plinga", "playable"].indexOf(config.source) !== -1) {
        return config.source;
    }

    var existParameterByName = function (name) {
        return window.location.href.indexOf(name) !== -1;
    };

    if (existParameterByName("logged_user_id")) {
        if (existParameterByName("mob=true")) {
            return "mobile_ok";
        }
        return "web_ok";
    }

    if (existParameterByName("api.vk.")) {
        if (existParameterByName("vkmobile=true")) {
            return "mobile_vk";
        }
        return "web_vk";
    }

    if (window.location.hostname.indexOf("mbga-platform.jp") !== -1) {
        return "mbga";
    }

    if (existParameterByName("dr_auth_code")) {
        return "draugiem";
    }

    if (existParameterByName("yandex")) {
        return "yandex";
    }

    return "facebook";
};

cleverappsSendRequest = function (method, url, message) {
    var oReq = new XMLHttpRequest();

    var basePath = "";

    var config = document.ccConfig;
    if (config) {
        var projectName = config.projectName;
        var source = cleverappsCalcSource();
        basePath = "/" + projectName + "-rest";

        if (["huzcom", "pliega", "playable"].indexOf(source) !== -1) {
            return;
        }

        if (["instant", "mbga", "plinga", "yandex"].indexOf(source) !== -1) {
            basePath = config.deployment + basePath;
        }
    }

    if (location.host === "localhost" || location.host === "127.0.0.1") {
        basePath = "http://localhost:3007";
    }

    oReq.open("POST", basePath + url);
    oReq.send(message);
};

LogTimeStart.prototype.save = function (passedTime) {
    if (passedTime === undefined) {
        passedTime = Math.round((Date.now() - this.started) / 1000);
        // console.log("Loaded in: " + passedTime);
    }

    cleverappsSendRequest("POST", "/timestart/" + this.id + "/" + passedTime + "/" + cleverappsCalcSource(), 1);
};

LogTimeStart.generateId = function () {
    var source = cleverappsCalcSource();
    if (source === "mobile_ok" || source === "web_ok") {
        var params = cleverappsGetRequestParameters();
        if (params.logged_user_id) {
            return params.logged_user_id;
        }
    }

    return Math.round(Math.random() * 1000000000);
};

if (typeof mobileOkReturned === "undefined" || !mobileOkReturned) {
    logTimeStart = new LogTimeStart(LogTimeStart.generateId());

    // Used from outer code
    // eslint-disable-next-line no-unused-vars
    var logTimeStartTimeout = setTimeout(function () {
        logTimeStartTimeout = undefined;
        logTimeStart.save(LogTimeStart.LONG);
    }, 30000);
}
